#!/bin/bash

source compcommon.sh

echo ------------ creating sources

M4 yyypostman.hpp.m4 yyypostman.hpp
M4 yyysigdeferer.hpp.m4 yyysigdeferer.hpp


echo ------------ compiling client stuff
function CCL
{
    CXX $C $CSIG $CGTKMM -c "$@"
}
CCL client.cpp
CCL yyygtkscheduler.cpp


echo ------------ compiling server stuff
function CSV
{
    CXX $C $CSIG -c "$@"
}
CSV server.cpp


echo ------------ compiling testprog stuff
function CTP
{
    CXX $C $CSIG -c "$@"
}
#CTP testprog.cpp


echo ------------ compiling common stuff
function CCM
{
    CXX $C $CSIG -c "$@"
}

CCM fatal.cpp
CCM rgbamap.cpp
CCM yyylowlevelnet.cpp
CCM yyysendables.cpp
CCM memchk.cpp
CCM yyyzeit.cpp
CCM yyybinbuff.cpp
CCM yyyexceptions.cpp
CCM ident.cpp
CCM selector.cpp
CCM yyyscheduler.cpp
CCM sendstring.cpp
CCM binload.cpp
CCM sprite.cpp
CCM eriksplugin.cpp
CCM sendbinbuff.cpp
CCM compsprite.cpp
CCM visor.cpp


echo ------------ linking client
CXX $L $LSIG $LGTKMM -o dicetalk client.o fatal.o yyysendables.o \
    rgbamap.o yyygtkscheduler.o yyylowlevelnet.o memchk.o yyyzeit.o \
    yyyexceptions.o ident.o sendstring.o sendbinbuff.o binload.o \
    compsprite.o sprite.o eriksplugin.o visor.o yyybinbuff.o


echo ------------ linking server
CXX $L $LSIG -o dicetalkserver yyysendables.o memchk.o yyylowlevelnet.o \
    server.o fatal.o yyyscheduler.o selector.o yyyzeit.o \
    yyyexceptions.o sendstring.o ident.o rgbamap.o sendbinbuff.o \
    compsprite.o visor.o yyybinbuff.o


echo ------------ linking testprog
#CXX $L $LSIG -o testprog testprog.o binload.o sprite.o yyyexceptions.o \
#    fatal.o eriksplugin.o yyybinbuff.o


echo ------------ done
