#include "eriksplugin.hpp"

#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>

void startplugin(const char *progname, char *const argv[], struct eriksplugin *ep)
{
  int sendtopluginpipe[2], recvfrompluginpipe[2];
  
  pipe(sendtopluginpipe);
  pipe(recvfrompluginpipe);

  ep->pid=fork();
  if (ep->pid==0) {
    /* child (i am the plugin) */
    close(sendtopluginpipe[1]);
    close(recvfrompluginpipe[0]);
    dup2(sendtopluginpipe[0],STDIN_FILENO);
    dup2(recvfrompluginpipe[1],STDOUT_FILENO);
    execv(progname,argv);
  } else {
    /* parent */
    close(sendtopluginpipe[0]);
    close(recvfrompluginpipe[1]);    
    ep->sendtoplugin=sendtopluginpipe[1];
    ep->recvfromplugin=recvfrompluginpipe[0];
  };
};

void killplugin(struct eriksplugin *ep)
{
  if (ep->sendtoplugin!=-1) close(ep->sendtoplugin);
  if (ep->recvfromplugin!=-1) close(ep->recvfromplugin);
  kill(ep->pid,SIGTERM);
  waitpid(ep->pid,NULL,0);
};
