#include "sendbinbuff.hpp"

#include "yyysendables.hpp"
#include "fatal.hpp"

using namespace yyybinbuff;

static const binbuff::index maxbinbufflen=500000;

void appendtobinbuffer (const yyybinbuff::binbuff &a, yyybinbuff::binbuff &b)
{
  if (a.size()>maxbinbufflen) fatal("appendtobinbuffer(binbuff,...): maxbinbufflen exceeded");
  appendtobinbuffer(a.size(), b);
  binbuff::index pos = b.size();
  b.resize(pos+a.size());
  memcpy(&b[pos], &a[0], a.size());
};

const yyybinbuff::binbuff::index readfrombinbuffer(yyybinbuff::binbuff &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos)
{
  binbuff::index read, mypos=pos, newsize;

  read = readfrombinbuffer(newsize, b, mypos);
  if (read<0) return read;
  if ((newsize<0) || (newsize>maxbinbufflen)) return -2;
  mypos += read;

  if (b.size()-mypos < newsize) return -1;
  a.resize (newsize);
  memcpy (&a[0], &b[mypos], newsize);
  mypos += newsize;
  
  return mypos-pos;
};
