#include "sendstring.hpp"

#include "fatal.hpp"
#include "yyysendables.hpp"

using namespace yyybinbuff;

static const binbuff::index maxstrlen=500;

void appendtobinbuffer (const string &a, binbuff &b)
{
  binbuff::index len = a.size();
  if (len>maxstrlen)
    fatal("appendtobinbuffer(string,...): maxstringsize exceeded");
  appendtobinbuffer(len, b);

  binbuff::index pos = b.size();
  b.resize(pos+len);

  for (binbuff::index i=0;i<len;++i) b[pos+i] = a[i];
};

const binbuff::index
readfrombinbuffer(string &a, const binbuff &b, const binbuff::index pos)
{
  binbuff::index len, read, mypos;
  read = readfrombinbuffer (len, b, pos);
  if (read < 0) return read;
  if ((len<0) || (len>maxstrlen)) return -2;
  mypos = pos + read;
  if (b.size()-mypos<len) return -1;

  a.resize(len);
  for (binbuff::index i=0;i<len;++i) a[i] = b[mypos+i];
  
  return read+len;
};
